
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" /><meta name="generator" content="Docutils 0.17.1: http://docutils.sourceforge.net/" />

    <title>varnishhist &#8212; Varnish version 6.0.11 documentation</title>
    <link rel="stylesheet" type="text/css" href="../_static/pygments.css" />
    <link rel="stylesheet" type="text/css" href="../_static/classic.css" />
    
    <script data-url_root="../" id="documentation_options" src="../_static/documentation_options.js"></script>
    <script src="../_static/jquery.js"></script>
    <script src="../_static/underscore.js"></script>
    <script src="../_static/doctools.js"></script>
    
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" />
    <link rel="next" title="varnishlog" href="varnishlog.html" />
    <link rel="prev" title="varnishd" href="varnishd.html" /> 
  </head><body>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="varnishlog.html" title="varnishlog"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="varnishd.html" title="varnishd"
             accesskey="P">previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../index.html">Varnish version 6.0.11 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="index.html" accesskey="U">The Varnish Reference Manual</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href="">varnishhist</a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <section id="varnishhist">
<span id="varnishhist-1"></span><h1>varnishhist<a class="headerlink" href="#varnishhist" title="Permalink to this headline">¶</a></h1>
<section id="varnish-request-histogram">
<h2>Varnish request histogram<a class="headerlink" href="#varnish-request-histogram" title="Permalink to this headline">¶</a></h2>
<dl class="field-list simple">
<dt class="field-odd">Manual section</dt>
<dd class="field-odd"><p>1</p>
</dd>
</dl>
<section id="synopsis">
<h3>SYNOPSIS<a class="headerlink" href="#synopsis" title="Permalink to this headline">¶</a></h3>
<p>varnishhist [-B &lt;factor&gt;] [-C] [-d] [-g &lt;request|vxid&gt;] [-h] [-L &lt;limit&gt;] [-n &lt;dir&gt;] [-p &lt;period&gt;] [-P responsetime] [-P reqbodytime] [-P size] [-P Bereqtime] [-P Beresptime] [-P BerespBodytime] [-P Besize] [-P &lt;[cb:]tag:[prefix]:field_num[:min:max]&gt;] [-q &lt;query&gt;] [-r &lt;filename&gt;] [-t &lt;seconds|off&gt;] [-T &lt;seconds&gt;] [-V]</p>
</section>
<section id="description">
<h3>DESCRIPTION<a class="headerlink" href="#description" title="Permalink to this headline">¶</a></h3>
<p>The varnishhist utility reads varnishd(1) shared memory logs and
presents a continuously updated histogram showing the distribution
of the last N requests by their processing.  The value of N and the
vertical scale are displayed in the top left corner.  The horizontal
scale is logarithmic.  Hits are marked with a pipe character (“|”),
and misses are marked with a hash character (“#”).</p>
<p>The following options are available:</p>
<dl class="option-list">
<dt><kbd><span class="option">-B <var>&lt;factor&gt;</var></span></kbd></dt>
<dd><p>Factor to bend time by. Particularly useful when [-r]eading from a vsl file. =1 process in near real time, &lt;1 slow-motion, &gt;1 time-lapse (useless unless reading from a file). At runtime, &lt; halves and &gt; doubles.</p>
</dd>
<dt><kbd><span class="option">-C</span></kbd></dt>
<dd><p>Do all regular expression and string matching caseless.</p>
</dd>
<dt><kbd><span class="option">-d</span></kbd></dt>
<dd><p>Process log records at the head of the log and exit.</p>
</dd>
<dt><kbd><span class="option">-g <var>&lt;request|vxid&gt;</var></span></kbd></dt>
<dd><p>The grouping of the log records. The default is to group by vxid.</p>
</dd>
<dt><kbd><span class="option">-h</span></kbd></dt>
<dd><p>Print program usage and exit</p>
</dd>
<dt><kbd><span class="option">-L <var>&lt;limit&gt;</var></span></kbd></dt>
<dd><p>Sets the upper limit of incomplete transactions kept before the oldest transaction is force completed. A warning record is synthesized when this happens. This setting keeps an upper bound on the memory usage of running queries. Defaults to 1000 transactions.</p>
</dd>
<dt><kbd><span class="option">-n <var>&lt;dir&gt;</var></span></kbd></dt>
<dd><p>Specify the varnishd working directory (also known as instance name) to get logs from. If -n is not specified, the host name is used.</p>
</dd>
<dt><kbd><span class="option">-p <var>&lt;period&gt;</var></span></kbd></dt>
<dd><p>Specified the number of seconds between screen refreshes. Default is 1 second, and can be changed at runtime by pressing the [0-9] keys (powers of 2 in seconds or + and - (double/halve the speed).</p>
</dd>
<dt><kbd><span class="option">-P <var>responsetime</var></span></kbd></dt>
<dd><p>Predefined client profile: graph the total time from start of request processing (first byte received) until ready to deliver the client response (field 3 of SLT_Timestamp Process: VSL tag).</p>
</dd>
<dt><kbd><span class="option">-P <var>reqbodytime</var></span></kbd></dt>
<dd><p>Predefined client profile: graph the time for reading the request body (field 3 of SLT_Timestamp ReqBody: VSL tag).</p>
</dd>
<dt><kbd><span class="option">-P <var>size</var></span></kbd></dt>
<dd><p>Predefined client profile: graph the size of responses (field 5 of SLT_ReqAcct  VSL tag).</p>
</dd>
<dt><kbd><span class="option">-P <var>Bereqtime</var></span></kbd></dt>
<dd><p>Predefined backend profile: graph the time from beginning of backend processing until a backend request is sent completely (field 3 of SLT_Timestamp Bereq: VSL tag).</p>
</dd>
<dt><kbd><span class="option">-P <var>Beresptime</var></span></kbd></dt>
<dd><p>Predefined backend profile: graph the time from beginning of backend processing until the response headers are being received completely (field 3 of SLT_Timestamp Beresp: VSL tag).</p>
</dd>
<dt><kbd><span class="option">-P <var>BerespBodytime</var></span></kbd></dt>
<dd><p>Predefined backend profile: graph the time from beginning of backend processing until the response body has been received (field 3 of SLT_Timestamp BerespBody: VSL tag).</p>
</dd>
<dt><kbd><span class="option">-P <var>Besize</var></span></kbd></dt>
<dd><p>Predefined backend profile: graph the backend response body size (field 5 of SLT_BereqAcct  VSL tag).</p>
</dd>
<dt><kbd><span class="option">-P <var>&lt;[cb:]tag:[prefix]:field_num[:min:max]&gt;</var></span></kbd></dt>
<dd><p>Graph the given custom definition defined as: an optional (c)lient or (b)ackend filter (defaults to client), the tag we’ll look for, a prefix to look for (can be empty, but must be terminated by a colon) and the field number of the value we are interested in. min and max are the boundaries of the graph in powers of ten and default to -6 and 3.</p>
</dd>
<dt><kbd><span class="option">-q <var>&lt;query&gt;</var></span></kbd></dt>
<dd><p>Specifies the VSL query to use.</p>
</dd>
<dt><kbd><span class="option">-r <var>&lt;filename&gt;</var></span></kbd></dt>
<dd><p>Read log in binary file format from this file. The file can be created with <code class="docutils literal notranslate"><span class="pre">varnishlog</span> <span class="pre">-w</span> <span class="pre">filename</span></code>.</p>
</dd>
<dt><kbd><span class="option">-t <var>&lt;seconds|off&gt;</var></span></kbd></dt>
<dd><p>Timeout before returning error on initial VSM connection. If set the VSM connection is retried every 0.5 seconds for this many seconds. If zero the connection is attempted only once and will fail immediately if unsuccessful. If set to “off”, the connection will not fail, allowing the utility to start and wait indefinetely for the Varnish instance to appear.  Defaults to 5 seconds.</p>
</dd>
<dt><kbd><span class="option">-T <var>&lt;seconds&gt;</var></span></kbd></dt>
<dd><p>Sets the transaction timeout in seconds. This defines the maximum number of seconds elapsed between a Begin tag and the End tag. If the timeout expires, a warning record is synthesized and the transaction is force completed. Defaults to 120 seconds.</p>
</dd>
<dt><kbd><span class="option">-V</span></kbd></dt>
<dd><p>Print version information and exit.</p>
</dd>
<dt><kbd><span class="option">--optstring</span></kbd></dt>
<dd><p>Print the optstring parameter to <code class="docutils literal notranslate"><span class="pre">getopt(3)</span></code> to help writing wrapper scripts.</p>
</dd>
</dl>
</section>
<section id="see-also">
<h3>SEE ALSO<a class="headerlink" href="#see-also" title="Permalink to this headline">¶</a></h3>
<ul class="simple">
<li><p><a class="reference internal" href="varnishd.html#varnishd-1"><span class="std std-ref">varnishd</span></a></p></li>
<li><p><a class="reference internal" href="varnishlog.html#varnishlog-1"><span class="std std-ref">varnishlog</span></a></p></li>
<li><p><a class="reference internal" href="varnishncsa.html#varnishncsa-1"><span class="std std-ref">varnishncsa</span></a></p></li>
<li><p><a class="reference internal" href="varnishstat.html#varnishstat-1"><span class="std std-ref">varnishstat</span></a></p></li>
<li><p><a class="reference internal" href="varnishtop.html#varnishtop-1"><span class="std std-ref">varnishtop</span></a></p></li>
<li><p><a class="reference internal" href="vsl.html#vsl-7"><span class="std std-ref">VSL</span></a></p></li>
</ul>
</section>
<section id="history">
<h3>HISTORY<a class="headerlink" href="#history" title="Permalink to this headline">¶</a></h3>
<p>The varnishhist utility was developed by Poul-Henning Kamp in cooperation with
Verdens Gang AS and Varnish Software AS. This manual page was written by
Dag-Erling Smørgrav.</p>
</section>
<section id="copyright">
<h3>COPYRIGHT<a class="headerlink" href="#copyright" title="Permalink to this headline">¶</a></h3>
<p>This document is licensed under the same licence as Varnish
itself. See LICENCE for details.</p>
<ul class="simple">
<li><p>Copyright (c) 2006 Verdens Gang AS</p></li>
<li><p>Copyright (c) 2006-2015 Varnish Software AS</p></li>
</ul>
</section>
</section>
</section>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../index.html">Table of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">varnishhist</a><ul>
<li><a class="reference internal" href="#varnish-request-histogram">Varnish request histogram</a><ul>
<li><a class="reference internal" href="#synopsis">SYNOPSIS</a></li>
<li><a class="reference internal" href="#description">DESCRIPTION</a></li>
<li><a class="reference internal" href="#see-also">SEE ALSO</a></li>
<li><a class="reference internal" href="#history">HISTORY</a></li>
<li><a class="reference internal" href="#copyright">COPYRIGHT</a></li>
</ul>
</li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="varnishd.html"
                        title="previous chapter">varnishd</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="varnishlog.html"
                        title="next chapter">varnishlog</a></p>
  <div role="note" aria-label="source link">
    <h3>This Page</h3>
    <ul class="this-page-menu">
      <li><a href="../_sources/reference/varnishhist.rst.txt"
            rel="nofollow">Show Source</a></li>
    </ul>
   </div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false"/>
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="varnishlog.html" title="varnishlog"
             >next</a> |</li>
        <li class="right" >
          <a href="varnishd.html" title="varnishd"
             >previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../index.html">Varnish version 6.0.11 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="index.html" >The Varnish Reference Manual</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href="">varnishhist</a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2010-2014, Varnish Software AS.
      Created using <a href="https://www.sphinx-doc.org/">Sphinx</a> 4.3.2.
    </div>
  </body>
</html>